#include "mlp_c.h"


static mlp_c_language_impl c ;


mlp_c_language_impl::mlp_c_language_impl() : mlp_language_impl("c"){
}


mlp_runtime_impl *mlp_c_language_impl::new_runtime_impl(mlp_context *ctx, const void *opts){
	ctx->clear_error() ;
	mlp_runtime *rt = new mlp_c_runtime_impl(ctx, this, opts) ;
	if (ctx->has_error()){
		rt->destroy(ctx) ;
		return NULL ;
	}
	return rt ;
}

