#include "mlp_haskell.h"


static mlp_haskell_language haskell ;


mlp_haskell_language::mlp_haskell_language() : mlp_language("haskell"){
}


mlp_runtime *mlp_haskell_language::new_runtime(mlp_context *ctx, const void *opts){
	ctx->clear_error() ;
	mlp_runtime *rt = new mlp_haskell_runtime(ctx, this, opts) ;
	if (ctx->has_error()){
		rt->destroy(ctx) ;
		return NULL ;
	}
	return rt ;
}

