plan_tests(5) ;

mlp_context ctx ;

mlp_language *lang = mlp_language::init(&ctx, MLP_TEST_LANG) ; // MLP_TEST_OPTS ;
MLP_CHECK_ERROR(ctx, 1){
	ok(lang != NULL, "Language %s initialized", MLP_TEST_LANG) ;
}
mlp_runtime *rt = lang->new_runtime(&ctx, NULL) ;
MLP_CHECK_ERROR(ctx, 1){
	ok(rt != NULL, "Runtime for %s created", MLP_TEST_LANG) ;
}
rt->setup_context(\&ctx) ;
MLP_CHECK_ERROR(ctx, 1){
	ok(rt != NULL, "Context set up for %s runtime", MLP_TEST_LANG) ;
}


rt->destroy(&ctx) ;
MLP_CHECK_ERROR(ctx, 1){
	pass("Runtime for %s destroyed", MLP_TEST_LANG) ;
}
lang->destroy(&ctx) ;
MLP_CHECK_ERROR(ctx, 1){
	pass("Language %s destroyed", MLP_TEST_LANG) ;
}
