#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


extern "C" {
	#include <tap.h>
}
#include "../src/mlp.h"


int do_test ;


#define MLP_CHECK_ERROR(c, n) \
	do_test = 1 ; \
	if (c.has_error()){ \
		switch (c.get_error()){ \
			case MLP_NOT_SUPPORTED: \
				skip(n, "Not supported by this language: %s", c.get_error_msg()) ; \
				do_test = 0 ; \
				break ; \
			case MLP_NOT_IMPLEMENTED: \
				skip(n, "Not implemented yet in this language: %s", c.get_error_msg()) ; \
				do_test = 0 ; \
				break ; \
			default: \
				for (int i = 0 ; i < n ; i++){ \
					fail("MLP ERROR %d: (%s)", c.get_error(), c.get_error_msg()) ; \
				} \
				break ; \
		} \
	} \
	if (do_test)

