package MLP::Utils ;
use strict ;


$MLP::Utils::DEBUG = 0 ;
$MLP::Utils::NAME = 'perl' ;


sub set_debug {
	my $pkg = shift ;
	my $d = shift ;

	$MLP::Utils::DEBUG = $d ;
}


sub get_debug {
	my $pkg = shift ;

	return $MLP::Utils::DEBUG ;
}


sub get_name {
	my $pkg = shift ;

	return $MLP::Utils::NAME ;
}


sub debug {
	my $pkg = shift ;
	my $level = shift ;
	my $msg = shift ;

	if (($MLP::Utils::DEBUG > 0)&&($MLP::Utils::DEBUG >= $level)){
		my $sname = $MLP::Utils::NAME . "    " ;
		print STDERR "# DEBUG(", substr($sname, 0, 4), "): " ;
		print STDERR (" " x $level), $msg, "\n" ;
	}
}



1 ;
