#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "../src/mlp_priv.h"
#include "mlp_c_priv.h"


void *_mlp_c_new_object(mlp_context *ctx, const mlp_class *class_, 
        int nb_args, const mlp_value **args, mlp_type return_type){
	mlp_context_set_error(ctx, MLP_NOT_SUPPORTED, "C does not support objects") ;
	return NULL ;
}


mlp_value *_mlp_c_call_method(mlp_context *ctx, const mlp_object *object, const char *name,
    int nb_args, const mlp_value **args, mlp_type return_type){
	mlp_context_set_error(ctx, MLP_NOT_SUPPORTED, "C does not support objects") ;
	return NULL ;
}


void _mlp_c_detach_object(mlp_context *ctx, const mlp_object *object){
	mlp_context_set_error(ctx, MLP_NOT_SUPPORTED, "C does not support objects") ;
}


void _mlp_c_delete_object(mlp_context *ctx, const mlp_object *object){
	mlp_context_set_error(ctx, MLP_NOT_SUPPORTED, "C does not support objects") ;
}

