#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <dlfcn.h>
#include <stdarg.h>

#include "../src/mlp_priv.h"
#include "mlp_perl_priv.h"


mlp_runtime_interface *_mlp_perl_init(mlp_context *ctx){
	mlp_runtime_interface *iface = MLP_GENERATE_INIT(iface, perl) ;

	return iface ;
}


void *_mlp_perl_new_runtime(mlp_context *ctx, const void *opts){
	PerlInterpreter *my_perl = NULL ;
	char *embedding[] = { "", "-e", "0" } ;

    my_perl = perl_alloc() ;
	perl_construct(my_perl) ;
	perl_parse(my_perl, NULL, 3, embedding, NULL) ;
	PL_exit_flags |= PERL_EXIT_DESTRUCT_END ; 
	perl_run(my_perl) ;

	return my_perl ;
}


void _mlp_perl_delete_runtime(mlp_context *ctx, void *runtime){
	/*
		perl_destruct(my_perl);
		perl_free(my_perl);
	*/
}
