#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "mlp_priv.h"



mlp_class *mlp_new_class(mlp_context *ctx, const char *name){
	mlp_context_clear_error(ctx) ;
	mlp_runtime_interface *iface = ctx->runtime->interface ;
	void *lang_class = (*(iface->new_class))(ctx, name) ;
	if (mlp_context_has_error(ctx)){
		return NULL ;
	}

	mlp_class *class_ = (mlp_class *)malloc(sizeof(mlp_class)) ;
	class_->name = strdup(name) ;
	class_->class_ = lang_class ;

	return class_ ;
}

