package MLP::Object ;
use strict ;


sub _alloc {
	my $pkg = shift ;
	my $class = shift ;
	my $handle = shift ;

	my $this = {
		class => $class,
		handle => $handle,
	} ;

	return bless($this, $pkg) ;
}


sub get_pkg_name {
	my $this = shift ;

	return $this->{class} ;
}


sub get_handle {
	my $this = shift ;

	return $this->{handle} ;
}


sub to_string {
	my $this = shift ;

	my $lang = MLP::Utils->get_name() ;
	if (defined $this->{handle}){
		return "$lang, $this->{class}, $this->{handle}" ;
	}
	else {
		return "$lang, $this->{class}, NULL" ;
	}
}


1 ;

