#include "mlp.h"


mlp_runtime::mlp_runtime(mlp_context *ctx, mlp_language *lang, const void *opts) : lang(lang){
}


mlp_runtime::~mlp_runtime(){
}


mlp_language *mlp_runtime::get_language(mlp_context *ctx){
	return lang ;
}
MLP_EXTERN_C mlp_language *mlp_runtime_get_language(mlp_context *ctx, mlp_runtime *rt){
	rt->get_language(ctx) ;
}


void mlp_runtime::destroy(mlp_context *ctx){
	delete this ;
}
MLP_EXTERN_C void mlp_runtime_destroy(mlp_context *ctx, mlp_runtime *rt){
	rt->destroy(ctx) ;
}


MLP_EXTERN_C void mlp_runtime_setup_context(mlp_context *ctx, mlp_runtime *rt){
    return rt->setup_context(ctx) ;
}


