#include "mlp_perl.h"


static mlp_perl_language perl ;


mlp_perl_language::mlp_perl_language() : mlp_language("perl"){
}


mlp_runtime *mlp_perl_language::new_runtime(mlp_context *ctx, const void *opts){
	ctx->clear_error() ;
	mlp_runtime *rt = new mlp_perl_runtime(ctx, this, opts) ;
	if (ctx->has_error()){
		rt->destroy() ;
		return NULL ;
	}
	return rt ;
}

