#!/bin/bash


MLP_TEST_LANG=${MLP_TEST_LANG:-c}
MLP_TEST_LANG="\"$MLP_TEST_LANG\""
MLP_TEST_OPTS="\"$MLP_TEST_OPTS\""

TESTS="*.t"

echo '#include "test.h"'
for t in $TESTS ; do
	name=$(basename $t .t)
	echo
	echo "void t_$name(){"
	echo "#line 1 \"$t\""
	cat $t | (while read line ; do 
		echo -e "\t$line" | 
		sed s"/MLP_TEST_LANG/$MLP_TEST_LANG/g" |
		sed s"/MLP_TEST_OPTS/$MLP_TEST_OPTS/g"
	done)
	echo }
done

echo
echo 'int main(int argc, char *argv[]){'
echo '	if (argc < 2) { fprintf(stderr, "Usage: test FILE\n") ; exit(1) ; }'
for t in $TESTS ; do
	name=$(basename $t .t)
	echo "	if (strcmp(argv[argc-1], \"$t\") == 0) { t_$name() ; }"
done
echo '	return exit_status() ;'
echo "}"


