#ifndef _MLP_HASKELL_H_
#define _MLP_HASKELL_H_

#include "../src/mlp.h"
#include "c/mlp_c.h"
#include <HsFFI.h>


class mlp_haskell_language : public mlp_language {
	public:
	mlp_haskell_language() ;
	virtual mlp_runtime *new_runtime(mlp_context *ctx, const void *opts) ;
} ;


class mlp_haskell_runtime : public mlp_c_runtime {
	protected:
	virtual ~mlp_haskell_runtime() ;
	public:
	mlp_haskell_runtime(mlp_context *ctx, mlp_language *lang, const void *opts) ;
	virtual void destroy(mlp_context *ctx) ;
	virtual mlp_library *load_library(mlp_context *ctx, const char *name, const void *opts) ;
} ;


#endif
