#ifndef _MLP_API_HPP_
#define _MLP_API_HPP_


#include "mlp.h"


#define MLP_ALLOC(t)	((t *)calloc(1, sizeof(t)))
#define MLP_FREE(p)		{free(p) ; p = NULL ;}


/* MLP Context */
struct _mlp_context {
	mlp_error err ;
	char *err_msg ;
} ;


/* MLP Value */
struct _mlp_value {
	mlp_type type ;
	union {
		int i ;
		long l ;
		double d ;
		char *s ;
		const mlp_array *a ;
		const mlp_object *o ;
	} v ;
	int thrown ;
	char *stringy ;
} ;


#endif
