/* Prototypes from mlp.cpp */

MLP_API void mlp_debug(int level, const char *fmt, ...) ;
/* Prototypes from context.cpp */

MLP_API mlp_context *mlp_context_new() ;
MLP_API void mlp_context_delete(mlp_context *ctx) ;
MLP_API int mlp_context_has_error(mlp_context *ctx) ;
MLP_API mlp_error mlp_context_get_error(mlp_context *ctx) ;
MLP_API const char *mlp_context_get_error_msg(mlp_context *ctx) ;
MLP_API void mlp_context_set_verror(mlp_context *ctx, mlp_error e, const char *fmt, va_list va) ;
MLP_API void mlp_context_set_error(mlp_context *ctx, mlp_error e, const char *fmt, ...) ;
MLP_API void mlp_context_clear_error(mlp_context *ctx) ;
MLP_API void mlp_context_set_runtime_data(mlp_context *ctx, mlp_runtime *rt, const void *data) ;
MLP_API void mlp_context_get_runtime_data(mlp_context *ctx, mlp_runtime *rt) ;
/* Prototypes from value.cpp */

