# 1 "shapes.h"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "shapes.h"







# 1 "object.h" 1
# 24 "object.h"
typedef struct Object *Object;
typedef struct ObjectClass *ObjectClass;
struct ObjectClass {
   size_t __size;
   ObjectClass __super;
   void (*Des)(Object);
};
extern struct ObjectClass __Object;
struct Object {
   ObjectClass __vptr;
};






int Object__IsKindOf(Object this, void *class);


Object Object__AllocArr(size_t size, short dim);
void Object__DeleteArr(Object obj);


void Object_NoIm(void);
# 9 "shapes.h" 2
# 1 "string.h" 1
# 11 "string.h"
typedef struct String *String; struct String {struct Object super;
   char *__buffer;
}; extern struct StringClass __String; typedef struct StringClass *StringClass; struct StringClass {struct ObjectClass super;
};

   String StringCon1(String this, const char *str);
   String StringCon2(String this, String other);


   void StringDes(String this);


   const char *StringToChar(String this);





struct StringClass __String; static void StringClassCon(String t){StringClass vptr=&__String; memcpy(vptr,((Object)t)->__vptr,sizeof(struct ObjectClass)); ((ObjectClass)vptr)->__size=sizeof(struct String);
   ((ObjectClass)vptr)->Des = (void (*)(Object))StringDes;
((ObjectClass)vptr)->__super=((Object)t)->__vptr;}

{if(((ObjectClass)&__String)->__size==0) StringClassCon(this); ((Object)(this))->__vptr=(void*)&__String;};
# 10 "shapes.h" 2


typedef struct Scaleable **Scaleable; struct Scaleable {ptrdiff_t __offset;
   void (*Scale)(Object, double);
};


typedef struct Shape *Shape; struct Shape {struct Object super; struct Scaleable *Scaleable;
   struct String name;
}; extern struct ShapeClass __Shape; typedef struct ShapeClass *ShapeClass; struct ShapeClass {struct ObjectClass super; struct Scaleable Scaleable;
   double (*Area)(Shape);
};
   Shape Shape_Con(Shape this, char *name);
   void Shape_Des(Shape this);



typedef struct Rect *Rect; struct Rect {struct Shape super;
   double __w;
   double __h;
}; extern struct RectClass __Rect; typedef struct RectClass *RectClass; struct RectClass {struct ShapeClass super;
};
   Rect RectCon(Rect this, char *name, double w, double h);
   double RectArea(Rect this);
   void RectScale(Rect this, double mag);



typedef struct Circle *Circle; struct Circle {struct Shape super;
   double __r;
}; extern struct CircleClass __Circle; typedef struct CircleClass *CircleClass; struct CircleClass {struct ShapeClass super;
};
   Circle CircleCon(Circle this, char* name, double r);
   double CircleArea(Circle this);
   void CircleScale(Circle this, double mag);


struct ShapeClass __Shape; static void ShapeClassCon(Shape t){ShapeClass vptr=&__Shape; memcpy(vptr,((Object)t)->__vptr,sizeof(struct ObjectClass)); ((ObjectClass)vptr)->__size=sizeof(struct Shape);
   ((ObjectClass)vptr)->Des = (void (*)(Object))Shape_Des;
   ((ShapeClass)vptr)->Area = (double (*)(Shape))Object_NoIm;
   if (vptr->Scaleable.__offset==0) vptr->Scaleable.__offset=(char*)&t->Scaleable-(char*)t; vptr->Scaleable.Scale = (void (*)(Object, double))Object_NoIm;
((ObjectClass)vptr)->__super=((Object)t)->__vptr;}

struct RectClass __Rect; static void RectClassCon(Rect t){RectClass vptr=&__Rect; memcpy(vptr,((Object)t)->__vptr,sizeof(struct ShapeClass)); ((ObjectClass)vptr)->__size=sizeof(struct Rect);
   ((ShapeClass)vptr)->Area = (double (*)(Shape))RectArea;
   if (vptr->super.Scaleable.__offset==0) vptr->super.Scaleable.__offset=(char*)&t->super.Scaleable-(char*)t; vptr->super.Scaleable.Scale = (void (*)(Object,
double))RectScale;
((ObjectClass)vptr)->__super=((Object)t)->__vptr;}
