#include "mlp_c.h"


static mlp_c_language c ;


mlp_c_language::mlp_c_language() : mlp_language("c"){
}


mlp_runtime *mlp_c_language::new_runtime(mlp_context *ctx, const void *opts){
	ctx->clear_error() ;
	mlp_runtime *rt = new mlp_c_runtime(ctx, this, opts) ;
	if (ctx->has_error()){
		rt->destroy(ctx) ;
		return NULL ;
	}
	return rt ;
}

