package mlp.java ;

import mlp.* ;
import mlp.java.* ;


class Something {
	public Something(String a){
		System.out.println(a) ;
	}
	public Something(short s, float f) throws java.lang.Exception {
		System.out.println(s + ", " + f) ;
	}
	public Something(long s, double f){
		System.out.println(s + ", " + f) ;
	}
	public long add(long i, long j){
		return i+j ;
	}
	public String q() throws Exception{
		throw new Exception("YO") ;
	}
}

class SomethingElse {
}



class Test {
	public static void main(String args[]){
		try {
			MLPUtils.setDebug(5) ;
			MLPValue o = MLPJavaAPI.createObject(
				"mlp.java.Something", 
				new MLPValue[] {
					new MLPValue(5), 
					new MLPValue(3.1416)
				}, 
				"(short,float)"
			) ;
			MLPJavaObject jo = (MLPJavaObject)o.getObject() ;
			show(jo.getObject()) ;

			MLPValue o2 = MLPJavaAPI.callMethod(jo, "q",
				new MLPValue[] {},
				null
			) ;
			if (o2.getThrown()){
				MLPJavaObject jo2 = (MLPJavaObject)o2.getObject() ;
				show(jo2.getObject()) ;
				MLPValue msg = MLPJavaAPI.callMethod(jo2, "getMessage",
					new MLPValue[] {},
					null
				) ;
				show(msg.getString()) ;
			}
			
		}
		catch (Exception e){
			e.printStackTrace() ;
		}
	}

	static void show(Object o){
		if (o == null){
			System.out.println("null") ;
		}
		else {
			System.out.println(o.getClass().getName() + ": " + o.toString()) ;
		}
	}
}
