#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "../src/mlp_priv.h"
#include "mlp_java_priv.h"


void *_mlp_java_load_library(mlp_context *ctx, const char *name, const void *opts){
	mlp_context_set_error(ctx, MLP_NOT_SUPPORTED, "Java doesn't support loading JAR files at runtime.") ;
	return NULL ;
}


mlp_value *_mlp_java_call_function(mlp_context *ctx, void *library, const char *name, 
	int nb_args, const mlp_value **args, mlp_type return_type){

	mlp_context_set_error(ctx, MLP_NOT_SUPPORTED, "Java doesn't support standalone functions.") ;
	return NULL ;
}
