module MLP.Type where
import Foreign.C.Types
import qualified MLP


toCInt :: MLP.Type -> CInt
toCInt MLP.BOOL = 0
toCInt MLP.LONG = 1
toCInt MLP.DOUBLE = 2
toCInt MLP.CHAR = 3
toCInt MLP.STRING = 4
toCInt MLP.OBJECT = 5
toCInt MLP.EXCEPTION = 6


fromCInt :: CInt -> MLP.Type
fromCInt 0 = MLP.BOOL
fromCInt 1 = MLP.LONG
fromCInt 2 = MLP.DOUBLE
fromCInt 3 = MLP.CHAR
fromCInt 4 = MLP.STRING
fromCInt 5 = MLP.OBJECT
fromCInt 6 = MLP.EXCEPTION
