#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#include "mlp.h"



void *_mlp_java_create_interpreter(mlp_context *ctx){
	return (void *)1 ;
}


void *_mlp_java_create_object(mlp_context *ctx, const char *class, va_list args){
	return (void *)1 ;
}


mlp_value *_mlp_java_call_function(mlp_context *ctx, mlp_type return_type, const char *pkg, const char *func, mlp_value *args){
	fprintf(stderr, "!!!%p %s %s\n", ctx, pkg, func) ;
	return NULL ;
}


mlp_interface *_mlp_java_init(mlp_context *ctx){
	static mlp_interface *iface = NULL ;
	if (iface == NULL){
		iface = malloc(sizeof(mlp_interface)) ;
		iface->create_interpreter = _mlp_java_create_interpreter ;
		iface->create_object = _mlp_java_create_object ;
		iface->call_function = _mlp_java_call_function ;
	}

	return iface ;
}
