#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <dlfcn.h>
#include <stdarg.h>

#include "mlp_priv.h"


namespace mlp {


private language::language(){
}


static language language::init(context *ctx, const char *name){
	ctx->clear_error() ;
	dlerror() ; 
	string buf = "libmlp_" + name + ".so" ;
	void *handle = dlopen(buf.c_str(), RTLD_LAZY) ;
	if (handle == NULL){
		ctx->set_error(MLP_DL_ERROR, "Can't open shared object %s: %s\n", buf, dlerror()) ;
		return NULL ;
	}
}


}
