#include <string.h>
#include <stdio.h>

#include <tap.h>
#include "../src/mlp_priv.h"


int do_test ;


#define MLP_CHECK_ERROR(c, n) \
	do_test = 1 ; \
	if (mlp_context_has_error(c)){ \
		switch (mlp_context_get_error(c)){ \
			case MLP_NOT_SUPPORTED: \
				skip(n, "Not supported by this language: %s", mlp_context_get_error_info(c)) ; \
				do_test = 0 ; \
				break ; \
			case MLP_NOT_IMPLEMENTED: \
				skip(n, "Not implemented yet in this language: %s", mlp_context_get_error_info(c)) ; \
				do_test = 0 ; \
				break ; \
			default: \
 				mlp_debug(5, "MLP ERROR: %d (%s)", \
					mlp_context_get_error(c), mlp_context_get_error_info(c)) ; \
				break ; \
		} \
	} \
	if (do_test)

