#!/bin/bash

# The default test language is C
MLP_TEST_LANG=${MLP_TEST_LANG:-c}
MLP_TEST_OPTS=${MLP_TEST_OPTS:-}

# Load the last setting if any
[ -f test.env ] && source test.env

if [ "$MLP_TEST_LANG" != "$LAST_MLP_TEST_LANG" -o "$MLP_TEST_OPTS" != "$LAST_MLP_TEST_OPTS" ] ; then
	echo "LAST_MLP_TEST_LANG=$MLP_TEST_LANG" > test.env
	echo "LAST_MLP_TEST_OPTS=$MLP_TEST_OPTS" >> test.env
	echo test.env
fi
